<template>
	<div>
		<div :class="$style.headerSpacer" aria-hidden="true">
			<GlobalHeaderPromoBar v-if="hasPromoBar" :key="promoBar.mainContent" :promo-bar="promoBar" spacer />
		</div>
		<header ref="header" :class="[$style.header, { [$style.hasVisibleScrollbar]: scrollBarWidth > 0 }]">
			<BaseButton smart="https://id/maincontent" appearance="tertiary" size="medium" :class="$style.skipToMainContent">
				Skip to main content
			</BaseButton>
			<nuxt-link class="screen-reader-only" to="/accessibility-commitment">Accessibility Statement</nuxt-link>
			<GlobalHeaderPromoBar
				v-if="hasPromoBar"
				:key="promoBar.mainContent"
				:promo-bar="promoBar"
				:scroll-bar-width="scrollBarWidth"
				@change="setHeaderHeight()"
			/>

			<div ref="headerInner" :class="[$style.headerInner, { [$style.mobileHide]: !showNavbar }]">
				<div :class="[$style.left, $style.flexItem]">
					<button
						v-if="Object.values(menuMobileDropdownsState).some((v) => v)"
						type="button"
						:class="$style.menuBack"
						@click="closeMobileDropdown"
					>
						<BaseIcon id="menu-backwards" name="chevron-left" title="Go Back" width="26" height="26" />
					</button>

					<button
						v-else
						type="button"
						:class="[$style.hamburger, { [$style.hamburgerActive]: isMenuMobileOpen }]"
						@click="toggleMenuMobile"
					>
						<span>Menu</span>
					</button>

					<nav v-if="menuItems.length > 0" :class="$style.menu">
						<ul class="u-nolist" :class="$style.menuNav">
							<template v-for="(item, index) in menuItems">
								<GlobalHeaderMenuDropdown
									v-if="(item.submenu && item.submenu.length) || item.showProductsSubmenu === 'Yes'"
									:key="index"
									:submenu="getSubmenu(item)"
									:products="(item.showProductsSubmenu === 'Yes' && header.products) || []"
									:item="item"
									:cta-text="(item.showProductsSubmenu === 'Yes' && header.desktopCtaText) || ''"
									:cta-link="(item.showProductsSubmenu === 'Yes' && header.desktopCtaLink) || null"
									:open-body-class="$style.isHeaderMenuDropdownOpen"
									@link-click="track($event.name)"
								/>

								<li v-else :key="index" :class="$style.menuItem">
									<AtomDynamicLinkComponent v-bind="item.link" :class="$style.menuLink" @click="track(item.text)">
										{{ item.text }}
									</AtomDynamicLinkComponent>
								</li>
							</template>
						</ul>
					</nav>
				</div>

				<div :class="[$style.center, $style.flexItem]">
					<nuxt-link :class="$style.logo" :to="{ name: 'index' }">
						<BaseIcon id="logo" name="logo" title="Molekule" />
					</nuxt-link>
				</div>
				<div :class="[$style.right, $style.flexItem]">
					<nav>
						<ul class="u-nolist" :class="$style.rightItems">
							<li
								v-for="(item, index) in menuItemsRight"
								:key="index"
								:class="[$style.rightItem, { [$style.onlyDesktop]: item.showOnMobile !== 'Yes' }]"
							>
								<AtomDynamicLinkComponent
									v-bind="item.link"
									:class="item.link.element === 'span' ? $style.rightItemText : $style.rightLink"
									@click="track(item.text)"
								>
									{{ item.text }}
								</AtomDynamicLinkComponent>
							</li>
							<li :class="$style.rightItem">
								<div :class="$style.cartWrapper">
									<client-only>
										<div v-if="LINE_ITEMS && LINE_ITEMS.length" :class="$style.cartIndicator" />
									</client-only>
									<button
										:class="$style.cartButton"
										type="button"
										:aria-expanded="String(isCartOpen)"
										aria-label="Go to the shopping cart"
										aria-controls="cart-panel"
										@click="toggleCart"
									>
										<BaseIcon
											name="cart"
											title="Shopping Cart"
											desc="Go to the shopping cart"
											width="20"
											height="20"
											fill="#535354"
										/>
									</button>
								</div>
							</li>
							<li v-if="cta" :class="[$style.rightItem, $style.onlyDesktop]">
								<div :class="$style.ctaWrapper" @click.capture="trackClickedTopnavCta">
									<BaseButton
										:smart="cta.ctaLink.url"
										:target="cta.ctaLink.target"
										size="medium"
										appearance="primary"
										add-to-cart-source="topnav"
									>
										{{ cta.ctaText }}
									</BaseButton>
								</div>
							</li>
						</ul>
					</nav>
				</div>
			</div>
		</header>

		<transition name="slide-from-right">
			<div v-if="isMenuMobileOpen" :class="$style.menuMobile">
				<BaseScrollLock v-if="isMenuMobileOpen" />
				<nav>
					<ul v-if="menuItems.length > 0" class="u-nolist">
						<template v-for="(item, index) in menuItems">
							<GlobalHeaderMenuDropdownMobile
								v-if="(item.submenu && item.submenu.length) || item.showProductsSubmenu === 'Yes'"
								:key="index"
								:item="item"
								:submenu="getSubmenu(item)"
								:products="(item.showProductsSubmenu === 'Yes' && header.products) || []"
								:is-dropdown-open="menuMobileDropdownsState[item.text]"
								@openDropdown="
									menuMobileDropdownsState = {
										...menuMobileDropdownsState,
										[item.text]: true,
									}
								"
								@linkClick="
									menuMobileDropdownsState = {
										...menuMobileDropdownsState,
										[item.text]: false,
									};
									clickMobile($event.name);
								"
							/>

							<li v-else :key="index">
								<AtomDynamicLinkComponent
									v-bind="item.link"
									class="u-font-secondary"
									:class="$style.menuMobileLink"
									@click="clickMobile(item.text)"
								>
									{{ item.text }}
								</AtomDynamicLinkComponent>
							</li>
						</template>
					</ul>

					<ul v-if="mobileSubLinks.length > 0" class="u-nolist" :class="$style.mobileSub">
						<li v-for="(item, index) in mobileSubLinks" :key="index">
							<AtomDynamicLinkComponent
								v-bind="item.link"
								class="u-font-secondary"
								:class="$style.menuMobileSubLink"
								@click="clickMobile(item.text)"
							>
								{{ item.text }}
							</AtomDynamicLinkComponent>
						</li>
					</ul>
				</nav>
			</div>
		</transition>

		<client-only>
			<!-- <GlobalCartPanel v-show="isCartOpen" ref="cartPanel" :is-cart-open="isCartOpen" @close="toggleCart" /> -->
			<MkSideCart ref="cartPanel" />
		</client-only>
	</div>
</template>

<script>
import GlobalHeaderMenuDropdown from '@components/global-header-menu-dropdown';
import GlobalHeaderMenuDropdownMobile from '@components/global-header-menu-dropdown-mobile';
import GlobalHeaderPromoBar from '@components/global-header-promo-bar';
import AtomDynamicLinkComponent from '@components/atom-dynamic-link-component';
import { mapState } from 'vuex';
import debounce from 'lodash/debounce';
import { prismicLinkToComponent } from '@/utils/prismic-helpers';
import matchesPath from '@/utils/matches-path';
import getFullUrl from '@/utils/get-full-url';
import { fromEntries } from '@/utils';
import { getLocaleMatchInRoutePath } from '@/utils/locale-helpers';
import MkSideCart from '~/components/D2C/organisms/MkSideCart/MkSideCart.vue';

const rafPromise = () =>
	new Promise((resolve) => {
		window.requestAnimationFrame(resolve);
	});

export default {
	components: {
		GlobalHeaderMenuDropdown,
		GlobalHeaderMenuDropdownMobile,
		GlobalHeaderPromoBar,
		AtomDynamicLinkComponent,
		MkSideCart,
	},

	data: () => ({
		isCartOpen: false,
		isMenuMobileOpen: false,
		menuMobileDropdownsState: {},
		showNavbar: true,
		lastScrollPos: 0,
		scrollBarWidth: 0,
	}),

	computed: {
		...mapState({ header: (state) => state.globalData.header }),
		//	...mapGetters('magento', ['cart']),
		...mapState('screen', ['medium']),
		...mapState('CART_STORE', ['LINE_ITEMS', 'CART_ID', 'HAS_QUOTE']),

		menuItems() {
			return this.header.menu.map(this.mapMenuItem).filter(Boolean);
		},

		menuItemsRight() {
			return this.header.menuRight.map(this.mapMenuItem).filter(Boolean);
		},

		mobileSubLinks() {
			return this.header.mobileLinks.map(this.mapMenuItem).filter(Boolean);
		},

		promoBar() {
			const { promoBars } = this.header;
			let { path } = this.$route;

			const localeMatchInRoutePath = getLocaleMatchInRoutePath(path);
			if (localeMatchInRoutePath) {
				path = path.substring(localeMatchInRoutePath.length + 1);
			}

			const promoBar = promoBars.find(({ path: barPaths, mainContent }) => {
				if (!(mainContent && typeof mainContent === 'string' && mainContent !== '<p></p>')) return false;
				if (!barPaths) return true;
				return matchesPath(path, barPaths.split(','));
			});

			if (!promoBar) return null;

			return {
				...promoBar,
				themeLowerCase: promoBar.theme.toLowerCase(),
			};
		},

		cta() {
			const { ctas } = this.header;
			const { path } = this.$route;

			const cta = ctas.find(({ path: ctaPaths, ctaLink }) => {
				if (!(ctaLink && ctaLink.url)) return false;
				if (!ctaPaths) return true;
				if (ctaPaths === path) return true;
				return matchesPath(path, ctaPaths.split(','));
			});

			return cta || null;
		},

		hasPromoBar() {
			const { promoBar } = this;
			if (!promoBar) return false;
			const localeMatchInRoute = getLocaleMatchInRoutePath(this.$route.path);
			const path = localeMatchInRoute
				? this.$route.path.substring(localeMatchInRoute.length + 1) || '/'
				: this.$route.path;
			if (
				path === '/legal' ||
				path === '/returns-and-warranty' ||
				path === '/share' ||
				path === '/healthcare' ||
				path === '/healthcare-inquiries' ||
				path === '/accessibility-commitment' ||
				path.includes('/D2C')
			)
				return false;
			return true;
		},
	},

	watch: {
		$route: 'routeChanged',

		CART_ID() {
			this.updateCartStatus(this.CART_ID);
		},
	},

	beforeMount() {
		this.scrollBarWidth = window.innerWidth - document.documentElement.clientWidth;
	},

	async mounted() {
		this.setHeaderHeight(true);
		this.ignoreScroll = false;
		this.track = debounce(this.track, 100);
		window.addEventListener('scroll', this.onScroll);
		this.updateCartStatus(this.CART_ID);
		await this.$store.dispatch('CHECKOUT_STORE/CHECK_LOCALE_FOR_FEATURE');
		await this.$store.dispatch('PRODUCT_STORE/GET_PRODUCTS');
	},

	beforeDestroy() {
		window.removeEventListener('scroll', this.onScroll);
	},

	methods: {
		mapMenuItem(item) {
			let { pagesWithMenuItem } = item;
			if (typeof pagesWithMenuItem === 'string') {
				pagesWithMenuItem = item.pagesWithMenuItem
					.split('\n')
					.map((x) => x.trim())
					.filter(Boolean);

				if (!pagesWithMenuItem.length || !pagesWithMenuItem.includes(this.$route.path)) return false;
			}

			const linkObject = item.link;
			let link;
			if (item.type === 'Button') {
				link = {
					element: 'BaseButton',
					props: {
						smart: linkObject && linkObject.url,
						appearance: 'secondary',
						size: 'medium',
					},
				};
			} else {
				link = prismicLinkToComponent(linkObject);
			}

			const submenu = this.header.submenuItems
				.filter((x) => x.topLevelText === item.text)
				.map(({ text, link }) => ({ text, link }));

			return { ...item, link, submenu };
		},

		getSubmenu(item) {
			return item.showProductsSubmenu !== 'Yes' && item.submenu && item.submenu.length ? item.submenu : [];
		},

		closeMobileDropdown() {
			this.menuMobileDropdownsState = fromEntries(
				Object.keys(this.menuMobileDropdownsState).map((key) => [key, false])
			);
		},

		toggleMenuMobile() {
			this.isMenuMobileOpen = !this.isMenuMobileOpen;
		},

		toggleCart() {
			this.isCartOpen = !this.isCartOpen;

			this.$nextTick(() => {
				this.$store.dispatch('MK_CART_STORE/TOGGLE_SIDE_CART', 'MK_SIDE_CART');
				if (this.isCartOpen) this.$refs.cartPanel.$el.focus();
			});
		},

		openCart() {
			this.isCartOpen = true;

			this.$nextTick(() => {
				this.$refs.cartPanel.$el.focus();
			});
		},

		clickMobile(name) {
			this.track(name);
			this.toggleMenuMobile();
		},

		track(name) {
			this.$tealiumEvent('header_click', {
				event_category: 'Header',
				event_action: 'Clicked Navigation Bar',
				event_label: name,
				header_value: name,
			});
		},

		trackClickedTopnavCta() {
			const { cta = {} } = this;
			const { ctaText, ctaLink = {} } = cta;
			if (!(ctaText && ctaLink.url)) return;

			this.$tealiumEvent('clicked_topnav_cta', {
				event_category: 'Learn More',
				event_action: 'Clicked Topnav CTA Button',
				event_label: getFullUrl(ctaLink.url),
				event_value: ctaText,
			});
		},

		routeChanged() {
			this.isCartOpen = false;
			this.showNavbar = true;
			this.setHeaderHeight(true);
			this.setHeaderHeight();

			// after route change ignore scroll for a moment to make sure we don't
			// hide navbar when content loads and set new position
			this.ignoreScroll = true;
			setTimeout(() => {
				this.ignoreScroll = false;
				this.onScroll();
				this.showNavbar = true;
				this.setHeaderHeight(true);
			}, 5000);
		},

		async setHeaderHeight(instant = false) {
			if (!instant) {
				await rafPromise();
				await rafPromise();
			}

			const { header } = this.$refs;
			const { headerInner } = this.$refs;
			const headerOffset = header.offsetHeight;
			const headerInnerHeight = headerInner.offsetHeight;
			this.headerHeight = this.showNavbar ? headerOffset : headerOffset - headerInnerHeight;
			this.headerHeightInner = headerInnerHeight;
			document.body.style.setProperty('--header-height', `${this.headerHeight}px`);
			document.body.style.setProperty('--header-height-full', `${headerOffset}px`);
		},

		getHeaderHeight() {
			return this.headerHeight || 60;
		},

		onScroll() {
			if (this.ignoreScroll) return;

			const currentScrollPosition = window.pageYOffset || document.documentElement.scrollTop;

			if (currentScrollPosition < 0 && this.showNavbar) return;

			if (Math.abs(currentScrollPosition - this.lastScrollPos) < this.headerHeightInner) return;

			this.showNavbar = this.medium || currentScrollPosition < this.lastScrollPos;

			this.setHeaderHeight(true);

			this.lastScrollPos = currentScrollPosition;
		},
		async updateCartStatus(cartId) {
			let cart = {};
			if (cartId) {
				cart = { cartID: cartId };
			}
			await this.$store.dispatch('CART_STORE/FETCH_CART', cart);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.skipToMainContent {
	position: absolute !important;
	top: 0;
	left: 0;
	z-index: 4;
	margin: 1rem 0 0 1.5rem;
	pointer-events: all;
	transform: translateY(calc(-100% - 1rem - 2px));

	&:focus {
		transform: translateY(0);
	}

	@include above('medium') {
		margin: 1.5rem 0 0 1.5rem;
		transform: translateY(calc(-100% - 1.5rem - 2px));
	}

	@include above('large') {
		margin: 1.25rem 0 0 5rem;
		transform: translateY(calc(-100% - 1.25rem - 2px));
	}
}

.headerSpacer {
	visibility: hidden;
}

.header {
	position: fixed;
	top: 0;
	left: 0;
	z-index: z-index('header-fixed');
	width: 100%;
	pointer-events: none;

	&.hasVisibleScrollbar {
		width: 100vw;
	}

	.isHeaderMenuDropdownOpen & {
		z-index: z-index('header-fixed-dropdown-open');
	}
}

.headerInner {
	position: relative;
	z-index: 1;
	display: flex;
	align-items: center;
	height: size('header');
	padding-right: 5rem;
	padding-left: 5rem;
	pointer-events: auto;
	background-color: color('white');
	box-shadow: 0 1px 0 0 #ececec;

	@include below('medium') {
		transition: transform 0.25s linear;
		transform: translate3d(0, 0, 0);
	}

	@include between(7.68rem, 'large') {
		padding-right: 1.5rem;
		padding-left: 1.5rem;
	}
}

.mobileHide {
	@include below('medium') {
		transform: translate3d(0, -100%, 0);
	}
}

.flexItem {
	flex: 1 1;
}

.left {
	display: flex;
	justify-content: flex-start;
	margin-right: auto;
}

.center {
	min-width: 11.5rem;
}

.logo {
	display: block;
	width: 100%;
	max-width: 11.5rem;
	height: 100%;
	margin: 0 auto;
}

.right {
	display: flex;
	justify-content: flex-end;
	margin-left: auto;
}

.menuBack {
	width: 4.4rem;
	height: 4.4rem;
	margin-right: 1rem;
	outline: 0;
}

.hamburger {
	position: relative;
	width: 2.4rem;
	height: 1.8rem;
	margin-right: 1rem;
	font-size: 0;
	outline: 0;

	@include above('medium') {
		display: none;
	}

	span {
		position: relative;
		display: block;
		width: 1005;
		height: 100%;
		outline: 0;

		&::before,
		&::after {
			position: absolute;
			top: 9px;
			right: 0;
			left: 0;
			height: 1px;
			content: '';
			background-color: color('primary');
			transition: all 0.3s;
		}
	}

	&::before,
	&::after {
		position: absolute;
		top: 0;
		right: 0;
		left: 0;
		height: 1px;
		content: '';
		background-color: color('primary');
		transition: all 0.3s;
	}

	&::after {
		top: 18px;
	}
}

.hamburgerActive {
	&::before,
	&::after {
		top: 9px;
		opacity: 0;
	}

	span::before {
		transform: rotate(45deg);
	}

	span::after {
		transform: rotate(-45deg);
	}
}

// Main menu
.menu {
	@include below('medium') {
		display: none;
	}
}

.menuNav {
	display: flex;
	align-items: center;
	height: 7.5rem;
}

.menuItem {
	margin-right: 5rem;
	white-space: nowrap;

	@include between(7.68rem, 'large') {
		margin-right: 1.5rem;
	}

	@include between('large', 'xlarge') {
		margin-right: 3.6rem;
	}
}

.menuLink {
	position: relative;
	display: inline-block;
	color: color('primary-200');

	@include use-text-style('type-100');

	@include above('medium') {
		padding: 2.85rem 0;
	}

	&::after {
		position: absolute;
		top: size('m++');
		right: 0;
		left: 0;
		height: 0.1rem;
		content: '';
		background-color: transparent;
		transition: all 0.4s ease;
	}
}

.menuLink:hover,
.menuLink:focus,
.menuLink:global(.nuxt-link-exact-active) {
	color: color('text');

	&::after {
		background-color: color('black');
	}
}

// Mobile menu
.menuMobile {
	position: fixed;
	top: size('header');
	top: var(--header-height, size('header'));
	right: 0;
	bottom: 0;
	z-index: z-index('header-mobile-menu');
	width: 100%;
	padding: 1rem 2rem;
	overflow-x: hidden;
	overflow-y: auto;
	background-color: color('white');

	@include above('medium') {
		display: none;
	}
}

.menuMobileLink {
	position: relative;
	display: block;
	padding: 0.5rem 0;

	@include use-text-style('heading-400');

	&:hover,
	&:focus {
		color: color('text');
	}
}

.mobileSub {
	margin-top: 3.6rem;
}

.menuMobileSubLink {
	display: block;
	padding: 0.8rem 0;

	@include use-text-style('heading-100');
}

// Right Items
.rightItems {
	display: flex;
	align-items: center;
}

.rightItem {
	margin-left: 1.5rem;

	@include above('large') {
		margin-left: 3.6rem;
	}

	@include above('xlarge') {
		margin-left: 5rem;
	}

	&:first-child {
		margin-left: 1.5rem;
	}

	&.onlyDesktop {
		@include below('medium') {
			display: none;
		}
	}
}

.rightItemText {
	position: relative;
	display: inline-block;
	color: color('primary-200');
	white-space: nowrap;

	@include use-text-style('type-100');

	@include above('medium') {
		padding: 2.85rem 0;
	}
}

.rightLink {
	// stylelint-disable-next-line
	composes: rightItemText;

	&::after {
		position: absolute;
		top: 5rem;
		right: 0;
		left: 0;
		height: 0.1rem;
		content: '';
		background-color: transparent;
		transition: all 0.4s ease;
	}

	&:hover,
	&:focus,
	&:global(.nuxt-link-exact-active) {
		color: color('text');

		&::after {
			background-color: color('black');
		}
	}
}

.cartWrapper {
	position: relative;
}

.cartIndicator {
	position: absolute;
	top: 50%;
	left: 19px;
	width: 0.6rem;
	height: 0.6rem;
	pointer-events: none;
	background-color: color('primary-200');
	border-radius: 50%;
}

.cartButton {
	display: flex;
	align-items: center;
	justify-content: center;
	width: 4.4rem;
	height: 4.4rem;
}

.ctaWrapper {
	white-space: nowrap;
}
</style>
